---
title: List maintenances
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Status Pages
---

# List maintenances{% #list-maintenances %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                      |
| ----------------- | ----------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/statuspages/maintenances |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/statuspages/maintenances |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/statuspages/maintenances      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/statuspages/maintenances      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/statuspages/maintenances  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/statuspages/maintenances     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/statuspages/maintenances |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/statuspages/maintenances |

### Overview

Lists all maintenances for the organization. Optionally filter by status and page. This endpoint requires the `status_pages_settings_read` permission.

OAuth apps require the `status_pages_settings_read` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#status-pages) to access this endpoint.



### Arguments

#### Query Strings

| Name            | Type    | Description                                                                                                          |
| --------------- | ------- | -------------------------------------------------------------------------------------------------------------------- |
| filter[page_id] | string  | Optional page id filter.                                                                                             |
| page[offset]    | integer | Offset to use as the start of the page.                                                                              |
| page[limit]     | integer | The number of maintenances to return per page.                                                                       |
| include         | string  | Comma-separated list of resources to include. Supported values: created_by_user, last_modified_by_user, status_page. |
| filter[status]  | string  | Optional maintenance status filter. Supported values: scheduled, in_progress, completed.                             |
| sort            | string  | Sort order. Prefix with '-' for descending. Supported values: created_at, -created_at, start_date, -start_date.      |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response object for a list of maintenances.

| Parent field          | Field                       | Type            | Description                                                                                                                                             |
| --------------------- | --------------------------- | --------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                       | data [*required*]      | [object]        | A list of maintenance data objects.                                                                                                                     |
| data                  | attributes                  | object          | The attributes of a maintenance.                                                                                                                        |
| attributes            | completed_date              | date-time       | Timestamp of when the maintenance was completed.                                                                                                        |
| attributes            | completed_description       | string          | The description shown when the maintenance is completed.                                                                                                |
| attributes            | components_affected         | [object]        | Components affected by the maintenance.                                                                                                                 |
| components_affected   | id [*required*]        | uuid            | The ID of the component. Must be a component of type `component`.                                                                                       |
| components_affected   | name                        | string          | The name of the component.                                                                                                                              |
| components_affected   | status [*required*]    | enum            | The status of the component. Allowed enum values: `operational,maintenance`                                                                             |
| attributes            | in_progress_description     | string          | The description shown while the maintenance is in progress.                                                                                             |
| attributes            | is_backfilled               | boolean         | Whether the maintenance was backfilled.                                                                                                                 |
| attributes            | modified_at                 | date-time       | Timestamp of when the maintenance was last modified.                                                                                                    |
| attributes            | published_date              | date-time       | Timestamp of when the maintenance was published.                                                                                                        |
| attributes            | scheduled_description       | string          | The description shown when the maintenance is scheduled.                                                                                                |
| attributes            | start_date                  | date-time       | Timestamp of when the maintenance is scheduled to start.                                                                                                |
| attributes            | status                      | enum            | The status of the maintenance. Allowed enum values: `scheduled,in_progress,completed`                                                                   |
| attributes            | title                       | string          | Title of the maintenance.                                                                                                                               |
| attributes            | updates                     | [object]        | Past updates made to the maintenance.                                                                                                                   |
| updates               | components_affected         | [object]        | The components affected at the time of the update.                                                                                                      |
| components_affected   | id [*required*]        | uuid            | Identifier of the component affected at the time of the update.                                                                                         |
| components_affected   | name                        | string          | The name of the component affected at the time of the update.                                                                                           |
| components_affected   | status [*required*]    | enum            | The status of the component affected at the time of the update. Allowed enum values: `operational,maintenance`                                          |
| updates               | created_at                  | date-time       | Timestamp of when the update was created.                                                                                                               |
| updates               | description                 | string          | Description of the update.                                                                                                                              |
| updates               | id                          | uuid            | Identifier of the update.                                                                                                                               |
| updates               | manual_transition           | boolean         | Whether the update was applied manually by a user (true) or automatically by the system (false).                                                        |
| updates               | modified_at                 | date-time       | Timestamp of when the update was last modified.                                                                                                         |
| updates               | started_at                  | date-time       | Timestamp of when the update started.                                                                                                                   |
| updates               | status                      | string          | The status of the update.                                                                                                                               |
| data                  | id                          | uuid            | The ID of the maintenance.                                                                                                                              |
| data                  | relationships               | object          | The relationships of a maintenance.                                                                                                                     |
| relationships         | created_by_user             | object          | The Datadog user who created the maintenance.                                                                                                           |
| created_by_user       | data [*required*]      | object          | The data object identifying the Datadog user who created the maintenance.                                                                               |
| data                  | id [*required*]        | uuid            | The ID of the Datadog user who created the maintenance.                                                                                                 |
| data                  | type [*required*]      | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| relationships         | last_modified_by_user       | object          | The Datadog user who last modified the maintenance.                                                                                                     |
| last_modified_by_user | data [*required*]      | object          | The data object identifying the Datadog user who last modified the maintenance.                                                                         |
| data                  | id [*required*]        | uuid            | The ID of the Datadog user who last modified the maintenance.                                                                                           |
| data                  | type [*required*]      | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| relationships         | status_page                 | object          | The status page the maintenance belongs to.                                                                                                             |
| status_page           | data [*required*]      | object          | The data object identifying the status page associated with a maintenance.                                                                              |
| data                  | id [*required*]        | uuid            | The ID of the status page.                                                                                                                              |
| data                  | type [*required*]      | enum            | Status pages resource type. Allowed enum values: `status_pages`                                                                                         |
| data                  | type [*required*]      | enum            | Maintenances resource type. Allowed enum values: `maintenances`                                                                                         |
|                       | included                    | [ <oneOf>] | The included related resources of a maintenance. Client must explicitly request these resources by name in the `include` query parameter.               |
| included              | Option 1                    | object          | The included Datadog user resource.                                                                                                                     |
| Option 1              | attributes                  | object          | Attributes of the Datadog user.                                                                                                                         |
| attributes            | email                       | string          | The email of the Datadog user.                                                                                                                          |
| attributes            | handle                      | string          | The handle of the Datadog user.                                                                                                                         |
| attributes            | icon                        | string          | The icon of the Datadog user.                                                                                                                           |
| attributes            | name                        | string          | The name of the Datadog user.                                                                                                                           |
| attributes            | uuid                        | string          | The UUID of the Datadog user.                                                                                                                           |
| Option 1              | id                          | uuid            | The ID of the Datadog user.                                                                                                                             |
| Option 1              | type [*required*]      | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| included              | Option 2                    | object          | The included status page resource.                                                                                                                      |
| Option 2              | attributes                  | object          | The attributes of a status page.                                                                                                                        |
| attributes            | company_logo                | string          | The base64-encoded image data displayed in the company logo.                                                                                            |
| attributes            | components                  | [object]        | Components displayed on the status page.                                                                                                                |
| components            | components                  | [object]        | If the component is of type `group`, the components within the group.                                                                                   |
| components            | id                          | uuid            | The ID of the grouped component.                                                                                                                        |
| components            | name                        | string          | The name of the grouped component.                                                                                                                      |
| components            | position                    | int64           | The zero-indexed position of the grouped component. Relative to the other components in the group.                                                      |
| components            | status                      | enum            | The status of the component. Allowed enum values: `operational,degraded,partial_outage,major_outage,maintenance`                                        |
| components            | type                        | enum            | The type of the component. Allowed enum values: `component`                                                                                             |
| components            | id                          | uuid            | The ID of the component.                                                                                                                                |
| components            | name                        | string          | The name of the component.                                                                                                                              |
| components            | position                    | int64           | The zero-indexed position of the component.                                                                                                             |
| components            | status                      | enum            | The status of the component. Allowed enum values: `operational,degraded,partial_outage,major_outage,maintenance`                                        |
| components            | type                        | enum            | The type of the component. Allowed enum values: `component,group`                                                                                       |
| attributes            | created_at                  | date-time       | Timestamp of when the status page was created.                                                                                                          |
| attributes            | custom_domain               | string          | If configured, the url that the status page is accessible at.                                                                                           |
| attributes            | custom_domain_enabled       | boolean         | Whether the custom domain is configured.                                                                                                                |
| attributes            | domain_prefix               | string          | The subdomain of the status page's url taking the form `https://{domain_prefix}.statuspage.datadoghq.com`. Globally unique across Datadog Status Pages. |
| attributes            | email_header_image          | string          | Base64-encoded image data included in email notifications sent to status page subscribers.                                                              |
| attributes            | enabled                     | boolean         | Whether the status page is enabled.                                                                                                                     |
| attributes            | favicon                     | string          | Base64-encoded image data displayed in the browser tab.                                                                                                 |
| attributes            | modified_at                 | date-time       | Timestamp of when the status page was last modified.                                                                                                    |
| attributes            | name                        | string          | The name of the status page.                                                                                                                            |
| attributes            | page_url                    | string          | The url that the status page is accessible at.                                                                                                          |
| attributes            | slack_app_icon              | string          | The Slack app icon URL for the status page.                                                                                                             |
| attributes            | slack_subscriptions_enabled | boolean         | Whether Slack subscriptions are enabled for the status page.                                                                                            |
| attributes            | subscriptions_enabled       | boolean         | Whether users can subscribe to the status page.                                                                                                         |
| attributes            | type                        | enum            | The type of the status page controlling how the status page is accessed. Allowed enum values: `public,internal`                                         |
| attributes            | visualization_type          | enum            | The visualization type of the status page. Allowed enum values: `bars_and_uptime_percentage,bars_only,component_name_only`                              |
| Option 2              | id                          | uuid            | The ID of the status page.                                                                                                                              |
| Option 2              | relationships               | object          | The relationships of a status page.                                                                                                                     |
| relationships         | created_by_user             | object          | The Datadog user who created the status page.                                                                                                           |
| created_by_user       | data [*required*]      | object          | The data object identifying the Datadog user who created the status page.                                                                               |
| data                  | id [*required*]        | string          | The ID of the Datadog user who created the status page.                                                                                                 |
| data                  | type [*required*]      | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| relationships         | last_modified_by_user       | object          | The Datadog user who last modified the status page.                                                                                                     |
| last_modified_by_user | data [*required*]      | object          | The data object identifying the Datadog user who last modified the status page.                                                                         |
| data                  | id [*required*]        | string          | The ID of the Datadog user who last modified the status page.                                                                                           |
| data                  | type [*required*]      | enum            | Users resource type. Allowed enum values: `users`                                                                                                       |
| Option 2              | type [*required*]      | enum            | Status pages resource type. Allowed enum values: `status_pages`                                                                                         |
|                       | meta                        | object          | Response metadata.                                                                                                                                      |
| meta                  | page                        | object          | Offset-based pagination schema.                                                                                                                         |
| page                  | first_offset                | int64           | Integer representing the offset to fetch the first page of results.                                                                                     |
| page                  | last_offset                 | int64           | Integer representing the offset to fetch the last page of results.                                                                                      |
| page                  | limit                       | int64           | Integer representing the number of elements to be returned in the results.                                                                              |
| page                  | next_offset                 | int64           | Integer representing the index of the first element in the next page of results. Equal to page size added to the current offset.                        |
| page                  | offset                      | int64           | Integer representing the index of the first element in the results.                                                                                     |
| page                  | prev_offset                 | int64           | Integer representing the index of the first element in the previous page of results.                                                                    |
| page                  | total                       | int64           | Integer representing the total number of elements available.                                                                                            |
| page                  | type                        | enum            | The pagination type used for offset-based pagination. Allowed enum values: `offset_limit`                                                               |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "attributes": {
        "completed_date": "2019-09-19T10:00:00.000Z",
        "completed_description": "string",
        "components_affected": [
          {
            "id": "1234abcd-12ab-34cd-56ef-123456abcdef",
            "name": "string",
            "status": "operational"
          }
        ],
        "in_progress_description": "string",
        "is_backfilled": false,
        "modified_at": "2019-09-19T10:00:00.000Z",
        "published_date": "2019-09-19T10:00:00.000Z",
        "scheduled_description": "string",
        "start_date": "2019-09-19T10:00:00.000Z",
        "status": "string",
        "title": "string",
        "updates": [
          {
            "components_affected": [
              {
                "id": "1234abcd-12ab-34cd-56ef-123456abcdef",
                "name": "string",
                "status": "operational"
              }
            ],
            "created_at": "2019-09-19T10:00:00.000Z",
            "description": "string",
            "id": "string",
            "manual_transition": false,
            "modified_at": "2019-09-19T10:00:00.000Z",
            "started_at": "2019-09-19T10:00:00.000Z",
            "status": "string"
          }
        ]
      },
      "id": "string",
      "relationships": {
        "created_by_user": {
          "data": {
            "id": "",
            "type": "users"
          }
        },
        "last_modified_by_user": {
          "data": {
            "id": "",
            "type": "users"
          }
        },
        "status_page": {
          "data": {
            "id": "",
            "type": "status_pages"
          }
        }
      },
      "type": "maintenances"
    }
  ],
  "included": [
    {
      "attributes": {
        "email": "string",
        "handle": "string",
        "icon": "string",
        "name": "string",
        "uuid": "string"
      },
      "id": "string",
      "type": "users"
    }
  ],
  "meta": {
    "page": {
      "first_offset": 0,
      "last_offset": 900,
      "limit": 100,
      "next_offset": 100,
      "offset": 0,
      "prev_offset": 100,
      "total": 1000,
      "type": "offset_limit"
    }
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/statuspages/maintenances" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
List maintenances returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.status_pages_api import StatusPagesApi

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = StatusPagesApi(api_client)
    response = api_instance.list_maintenances()

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# List maintenances returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::StatusPagesAPI.new
p api_instance.list_maintenances()
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// List maintenances returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStatusPagesApi(apiClient)
	resp, r, err := api.ListMaintenances(ctx, *datadogV2.NewListMaintenancesOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StatusPagesApi.ListMaintenances`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `StatusPagesApi.ListMaintenances`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// List maintenances returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StatusPagesApi;
import com.datadog.api.client.v2.model.MaintenanceArray;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    StatusPagesApi apiInstance = new StatusPagesApi(defaultClient);

    try {
      MaintenanceArray result = apiInstance.listMaintenances();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling StatusPagesApi#listMaintenances");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// List maintenances returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_status_pages::ListMaintenancesOptionalParams;
use datadog_api_client::datadogV2::api_status_pages::StatusPagesAPI;

#[tokio::main]
async fn main() {
    let configuration = datadog::Configuration::new();
    let api = StatusPagesAPI::with_config(configuration);
    let resp = api
        .list_maintenances(ListMaintenancesOptionalParams::default())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * List maintenances returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.StatusPagesApi(configuration);

apiInstance
  .listMaintenances()
  .then((data: v2.MaintenanceArray) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
